#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 Red

extern int PERIOD = 9;
double Gd_80 = 1.2;
extern int SL_add_pips = 16;
extern int TP_distance_pips = 27;
extern bool EmailAlerts = TRUE;
extern string text_options = "=== Text Options ===";
extern int X = 10;
extern int Y = 10;
extern int CORNER = 3;
extern string FONT_NAME = "Courier New";
extern int FONT_SIZE = 12;
extern color TEXT_COLOR = Yellow;
int Gi_136 = 0;
int G_ma_method_140 = MODE_SMA;
int G_applied_price_144 = PRICE_CLOSE;
double G_ibuf_148[];
double G_ibuf_152[];
double G_ibuf_156[];
double G_ibuf_160[];
double G_ibuf_164[];
double G_ibuf_168[];
double G_ibuf_172[];
datetime G_time_176;

// AA82CF3A41CEBBF1D981F099A58AD043
void f0_1(string As_0, double Ad_8, double Ad_16, double Ad_24) {
   string Ls_32;
   string Ls_40;
   string Ls_48;
   string Ls_56;
   string Ls_64;
   if (Time[0] != G_time_176) {
      G_time_176 = Time[0];
      if (Ad_24 != 0.0) Ls_48 = " at price " + DoubleToStr(Ad_24, 4);
      else Ls_48 = "";
      if (Ad_8 != 0.0) Ls_40 = ", TakeProfit on " + DoubleToStr(Ad_8, 4);
      else Ls_40 = "";
      if (Ad_16 != 0.0) Ls_32 = ", StopLoss on " + DoubleToStr(Ad_16, 4);
      else Ls_32 = "";
      Alert("SUPERFAST " + As_0 + Ls_48 + Ls_40 + Ls_32 + " ", Symbol(), ", ", Period(), " minutes chart");
      Ls_56 = "SUPERFAST  " + As_0 + Ls_48;
      Ls_64 = "SUPERFAST  " + As_0 + Ls_48 + Ls_40 + Ls_32 + " " + Symbol() + ", " + Period() + " minutes chart";
      if (EmailAlerts) SendMail(Ls_56, Ls_64);
   }
}

// E37F0136AA3FFAF149B351F6A4C948E9
int init() {
   IndicatorBuffers(7);
   SetIndexBuffer(0, G_ibuf_148);
   SetIndexBuffer(1, G_ibuf_152);
   SetIndexBuffer(2, G_ibuf_156);
   SetIndexBuffer(3, G_ibuf_160);
   SetIndexBuffer(4, G_ibuf_164);
   SetIndexBuffer(5, G_ibuf_168);
   SetIndexBuffer(6, G_ibuf_172);
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexLabel(0, "SUPERFAST ");
   SetIndexLabel(0, "SUPERFAST ");
   SetIndexShift(0, Gi_136);
   SetIndexShift(1, Gi_136);
   SetIndexEmptyValue(0, 0);
   SetIndexEmptyValue(1, 0);
   IndicatorDigits(Digits);
   IndicatorShortName("SuperFast (" + PERIOD + ")");
   if (PERIOD < 2) PERIOD = 2;
   SetIndexLabel(0, "1");
   SetIndexLabel(1, "2");
   SetIndexLabel(2, "3");
   SetIndexLabel(3, "4");
   SetIndexDrawBegin(0, PERIOD - 1);
   SetIndexDrawBegin(1, PERIOD - 1);
   SetIndexDrawBegin(2, PERIOD - 1);
   SetIndexDrawBegin(3, PERIOD - 1);
   Gd_80 /= 100.0;
   return (0);
}

// 52D46093050F38C27267BCE42543EF60
void deinit() {
   ObjectDelete("Text_SIGNAL");
   WindowRedraw();
}

// EA2B2676C28C0DB26D39331A336C6B92
int start() {
   double close_0;
   double Ld_8;
   double Ld_16;
   int Li_24;
   if (Bars <= PERIOD) return (0);
   int ind_counted_28 = IndicatorCounted();
   if (ind_counted_28 < 0) return (-1);
   if (ind_counted_28 == 0) {
      Li_24 = Bars - PERIOD - 1;
      for (int index_32 = 0; index_32 < Bars; index_32++) {
         G_ibuf_148[index_32] = 0;
         G_ibuf_152[index_32] = 0;
      }
   } else Li_24 = Bars - ind_counted_28 - 1;
   for (int Li_36 = Li_24; Li_36 > 0; Li_36--) {
      G_ibuf_164[Li_36] = (Gd_80 / 100.0 + 1.0) * iMA(NULL, 0, PERIOD, 0, G_ma_method_140, G_applied_price_144, Li_36);
      G_ibuf_168[Li_36] = (1 - Gd_80 / 100.0) * iMA(NULL, 0, PERIOD, 0, G_ma_method_140, G_applied_price_144, Li_36);
      G_ibuf_172[Li_36] = G_ibuf_172[Li_36 + 1];
      if (Close[Li_36] > G_ibuf_164[Li_36 + 1]) G_ibuf_172[Li_36] = 1;
      if (Close[Li_36] < G_ibuf_168[Li_36 + 1]) G_ibuf_172[Li_36] = -1;
      G_ibuf_156[Li_36] = 0;
      G_ibuf_160[Li_36] = 0;
      if (G_ibuf_172[Li_36] > 0.0) {
         if (G_ibuf_168[Li_36] < G_ibuf_168[Li_36 + 1]) G_ibuf_168[Li_36] = G_ibuf_168[Li_36 + 1];
         G_ibuf_148[Li_36] = G_ibuf_168[Li_36];
         if (G_ibuf_172[Li_36 + 1] < 0.0) G_ibuf_156[Li_36] = Low[Li_36] - iATR(NULL, 0, PERIOD, Li_36) / 2.0;
         G_ibuf_152[Li_36] = 0;
      } else {
         if (G_ibuf_164[Li_36] > G_ibuf_164[Li_36 + 1]) G_ibuf_164[Li_36] = G_ibuf_164[Li_36 + 1];
         G_ibuf_152[Li_36] = G_ibuf_164[Li_36];
         if (G_ibuf_172[Li_36 + 1] > 0.0) G_ibuf_160[Li_36] = High[Li_36] + iATR(NULL, 0, PERIOD, Li_36) / 2.0;
         G_ibuf_148[Li_36] = 0;
      }
      if (Li_36 == 1) {
         close_0 = Close[1];
         if (G_ibuf_156[1] != 0.0 && G_ibuf_160[1] == 0.0) {
            Ld_8 = Low[1] - SL_add_pips * Point;
            Ld_16 = close_0 + TP_distance_pips * Point;
            f0_1("Buy signal", Ld_16, Ld_8, close_0);
         }
         if (G_ibuf_160[1] != 0.0 && G_ibuf_156[1] == 0.0) {
            Ld_8 = High[1] + SL_add_pips * Point;
            Ld_16 = close_0 - TP_distance_pips * Point;
            f0_1("Sell signal", Ld_16, Ld_8, close_0);
         }
      }
   }
   string Ls_40 = "";
   if (G_ibuf_148[1] > 0.0) Ls_40 = "LATEST SIGNAL: BUY - TREND BULLISH";
   if (G_ibuf_152[1] > 0.0) Ls_40 = "LATEST SIGNAL: SELL - TREND BEARISH";
   f0_0("Text_SIGNAL", Ls_40, TEXT_COLOR, X, Y, CORNER);
   return (0);
}

// 25648F908BDC21257A45044512A011C9
void f0_0(string A_name_0, string A_text_8, color A_color_16, int A_x_20, int A_y_24, int A_corner_28) {
   if (ObjectFind(A_name_0) == 0 || ObjectCreate(A_name_0, OBJ_LABEL, 0, 0, 0)) {
      ObjectSet(A_name_0, OBJPROP_COLOR, A_color_16);
      ObjectSet(A_name_0, OBJPROP_XDISTANCE, A_x_20);
      ObjectSet(A_name_0, OBJPROP_YDISTANCE, A_y_24);
      ObjectSet(A_name_0, OBJPROP_CORNER, A_corner_28);
      ObjectSet(A_name_0, OBJPROP_FONTSIZE, FONT_SIZE);
      ObjectSetText(A_name_0, A_text_8, FONT_SIZE, FONT_NAME);
   }
}
